﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Rhino.Geometry;
using System.Globalization;

namespace RHNCRS.Base
{
    class Code
    {
        public void TestBrepSplitSameTexture(Rhino.RhinoDoc rhinoDoc)
		{
			var linearTolerance = 1e-5;

			var wx1 = 100;
			var wx2 = 1100;
			var wy1 = 100;
			var wy2 = 800;

			var imagefilename = System.IO.Path.Combine(System.IO.Path.GetDirectoryName(System.Reflection.Assembly.GetExecutingAssembly().Location), "sample.jpg");

			{
				var plane = Rhino.Geometry.Plane.WorldXY;
				plane.OriginX = wx1;
				plane.OriginY = wy1;
				var id = rhinoDoc.Objects.AddPictureFrame(plane, imagefilename, false, wx2 - wx1, wy2 - wy1, false, true);

				var originalRhinoObject = rhinoDoc.Objects.Find(id);

				var originalBrep = originalRhinoObject.Geometry as Brep;

				var cx1 = 200;
				var cy1 = 200;
				var cx2 = 400;
				var cy2 = 300;

				plane.OriginX = cx1;
				plane.OriginY = cy1;
				var cutterCurve = new Rectangle3d(plane, cx2 - cx1, cy2 - cy1).ToNurbsCurve();
				var cutterExtruction = Surface.CreateExtrusion(cutterCurve, plane.ZAxis * 2);
				cutterExtruction.Transform(Rhino.Geometry.Transform.Translation(0, 0, -1));

				var splits = originalBrep.Split(cutterExtruction.ToBrep(), linearTolerance);

				var resultBrep = splits.OrderBy(itm => itm.GetBoundingBox(true).Min.Y).Last();

				var attributes = originalRhinoObject.Attributes;

				var resultRhinoObjectId = rhinoDoc.Objects.Add(resultBrep, attributes);

				var resultRhinoObject = rhinoDoc.Objects.Find(resultRhinoObjectId);

				resultRhinoObject.Geometry.Transform(Rhino.Geometry.Transform.Translation(1234, 0, 0));

				resultRhinoObject.CommitChanges();

				rhinoDoc.Views.Redraw();

				rhinoDoc.Views.ActiveView.ActiveViewport.ZoomExtents();

				rhinoDoc.Views.Redraw();
			}
			//else
			//{
			//	var material = new Rhino.DocObjects.Material();
			//	material.Transparency = 0.6;
			//	material.SetBitmapTexture(imagefilename);
			//	material.Name = "Name";
			//	int idMaterial = Rhino.RhinoDoc.ActiveDoc.Materials.Add(material);
			//	material.Dispose();
			//	material = null;

			//	Brep brep = Rhino.Geometry.Brep.CreateFromCornerPoints(new Point3d(wx1, wy1, 0),
			//														   new Point3d(wx2, wy1, 0),
			//														   new Point3d(wx2, wy2, 0),
			//														   new Point3d(wx1, wy2, 0),
			//														   Rhino.RhinoDoc.ActiveDoc.ModelAbsoluteTolerance);

			//	var objectAttributes = new Rhino.DocObjects.ObjectAttributes();
			//	objectAttributes.LayerIndex = Rhino.RhinoDoc.ActiveDoc.Layers.CurrentLayerIndex;
			//	objectAttributes.MaterialIndex = idMaterial;
			//	objectAttributes.MaterialSource = Rhino.DocObjects.ObjectMaterialSource.MaterialFromObject;
			//	objectAttributes.Name = "ObjectAttributes";
			//	var objId = Rhino.RhinoDoc.ActiveDoc.Objects.Add(brep, objectAttributes);
			//	brep.Dispose();
			//	brep = null;
			//	objectAttributes.Dispose();
			//	objectAttributes = null;
			//}

		}

    }
}
